## libvirt 6.9.0

=== meson_options.txt ===
option('no_git', type: 'boolean', value: false, description: 'Disable git submodule update')
option('packager', type: 'string', value: '', description: 'Extra packager name')
option('packager_version', type: 'string', value: '', description: 'Extra packager version')
option('system', type: 'boolean', value: false, description: 'Set install paths to system ones')
option('runstatedir', type: 'string', value: '', description: 'State directory for temporary sockets, pid files, etc')
option('expensive_tests', type: 'feature', value: 'auto', description: 'set the default for enabling expensive tests (long timeouts)')
option('test_coverage', type: 'boolean', value: false, description: 'turn on code coverage instrumentation')
option('git_werror', type: 'feature', value: 'auto', description: 'use -Werror if building from GIT')
option('rpath', type: 'feature', value: 'auto', description: 'whether to include rpath information in installed binaries and libraries')
option('docs', type: 'feature', value: 'auto', description: 'whether to generate documentation')
option('tests', type: 'feature', value: 'auto', description: 'whether to build tests')


# build dependencies options
option('apparmor', type: 'feature', value: 'auto', description: 'apparmor support')
option('attr', type: 'feature', value: 'auto', description: 'attr support')
option('audit', type: 'feature', value: 'auto', description: 'audit support')
option('bash_completion', type: 'feature', value: 'auto', description: 'bash-completion support')
option('bash_completion_dir', type: 'string', value: '', description: 'directory containing bash completion scripts')
option('blkid', type: 'feature', value: 'auto', description: 'blkid support')
option('capng', type: 'feature', value: 'auto', description: 'cap-ng support')
option('curl', type: 'feature', value: 'auto', description: 'curl support')
option('fuse', type: 'feature', value: 'auto', description: 'fuse support')
option('glusterfs', type: 'feature', value: 'auto', description: 'glusterfs support')
option('libiscsi', type: 'feature', value: 'auto', description: 'libiscsi support')
option('libnl', type: 'feature', value: 'auto', description: 'libnl support')
option('libpcap', type: 'feature', value: 'auto', description: 'libpcap support')
option('libssh', type: 'feature', value: 'auto', description: 'libssh support')
option('libssh2', type: 'feature', value: 'auto', description: 'libssh2 support')
option('netcf', type: 'feature', value: 'auto', description: 'netcf support')
option('nls', type: 'feature', value: 'auto', description: 'nls support')
option('numactl', type: 'feature', value: 'auto', description: 'numactl support')
option('openwsman', type: 'feature', value: 'auto', description: 'openwsman support')
option('pciaccess', type: 'feature', value: 'auto', description: 'pciaccess support')
option('polkit', type: 'feature', value: 'auto', description: 'use PolicyKit for UNIX socket access checks')
option('readline', type: 'feature', value: 'auto', description: 'readline support')
option('sanlock', type: 'feature', value: 'auto', description: 'sanlock support')
option('sasl', type: 'feature', value: 'auto', description: 'sasl support')
option('selinux', type: 'feature', value: 'auto', description: 'selinux support')
option('selinux_mount', type: 'string', value: '', description: 'set SELinux mount point')
option('udev', type: 'feature', value: 'auto', description: 'udev support')
option('wireshark_dissector', type: 'feature', value: 'auto', description: 'wireshark support')
option('wireshark_plugindir', type: 'string', value: '', description: 'wireshark plugins directory for use when installing wireshark plugin')
option('yajl', type: 'feature', value: 'auto', description: 'yajl support')


# build driver options
option('driver_bhyve', type: 'feature', value: 'auto', description: 'bhyve driver')
option('driver_esx', type: 'feature', value: 'auto', description: 'esx driver')
option('driver_hyperv', type: 'feature', value: 'auto', description: 'Hyper-V driver')
option('driver_interface', type: 'feature', value: 'auto', description: 'host interface driver')
option('driver_libvirtd', type: 'feature', value: 'auto', description: 'libvirtd driver')
option('driver_libxl', type: 'feature', value: 'auto', description: 'libxenlight driver')
option('driver_lxc', type: 'feature', value: 'auto', description: 'Linux Container driver')
option('driver_network', type: 'feature', value: 'auto', description: 'virtual network driver')
option('driver_openvz', type: 'feature', value: 'auto', description: 'OpenVZ driver')
option('driver_qemu', type: 'feature', value: 'auto', description: 'QEMU/KVM driver')
option('qemu_user', type: 'string', value: '', description: 'username to run QEMU system instance as')
option('qemu_group', type: 'string', value: '', description: 'groupname to run QEMU system instance as')
option('qemu_moddir', type: 'string', value: '', description: 'set the directory where QEMU modules are located')
option('driver_remote', type: 'feature', value: 'enabled', description: 'remote driver')
option('remote_default_mode', type: 'combo', choices: ['legacy', 'direct'], value: 'legacy', description: 'remote driver default mode')
option('driver_secrets', type: 'feature', value: 'auto', description: 'local secrets management driver')
option('driver_test', type: 'feature', value: 'enabled', description: 'test driver')
option('driver_vbox', type: 'feature', value: 'auto', description: 'VirtualBox XPCOMC driver')
option('vbox_xpcomc_dir', type: 'string', value: '', description: 'Location of directory containing VirtualBox XPCOMC library')
option('driver_vmware', type: 'feature', value: 'auto', description: 'VMware driver')
option('driver_vz', type: 'feature', value: 'auto', description: 'Virtuozzo driver')

option('secdriver_apparmor', type: 'feature', value: 'auto', description: 'use AppArmor security driver')
option('apparmor_profiles', type: 'boolean', value: false, description: 'install apparmor profiles')
option('secdriver_selinux', type: 'feature', value: 'auto', description: 'use SELinux security driver')


# storage driver options
option('storage_dir', type: 'feature', value: 'auto', description: 'directory backend for the storage driver')
option('storage_disk', type: 'feature', value: 'auto', description: 'GPartd Disk backend for the storage driver')
option('storage_fs', type: 'feature', value: 'auto', description: 'FileSystem backend for the storage driver')
option('storage_gluster', type: 'feature', value: 'auto', description: 'Gluster backend for the storage driver')
option('storage_iscsi', type: 'feature', value: 'auto', description: 'iscsi backend for the storage driver')
option('storage_iscsi_direct', type: 'feature', value: 'auto', description: 'iscsi-direct backend for the storage driver')
option('storage_lvm', type: 'feature', value: 'auto', description: 'LVM backend for the storage driver')
option('storage_mpath', type: 'feature', value: 'auto', description: 'mpath backend for the storage driver')
option('storage_rbd', type: 'feature', value: 'auto', description: 'RADOS Block Device backend for the storage driver')
option('storage_scsi', type: 'feature', value: 'auto', description: 'SCSI backend for the storage driver')
option('storage_sheepdog', type: 'feature', value: 'auto', description: 'Sheepdog backend for the storage driver')
option('storage_vstorage', type: 'feature', value: 'auto', description: 'Virtuozzo storage backend for the storage driver')
option('storage_zfs', type: 'feature', value: 'auto', description: 'ZFS backend for the storage driver')


# build feature options
option('chrdev_lock_files', type: 'string', value: '', description: 'location for UUCP style lock files for character devices (leave empty for default paths on some platforms)')
option('dtrace', type: 'feature', value: 'auto', description: 'use dtrace for static probing')
option('firewalld', type: 'feature', value: 'auto', description: 'firewalld support')
option('firewalld_zone', type: 'feature', value: 'auto', description: 'whether to install firewalld libvirt zone')
option('host_validate', type: 'feature', value: 'auto', description: 'build virt-host-validate')
option('init_script', type: 'combo', choices: ['systemd', 'openrc', 'check', 'none'], value: 'check', description: 'Style of init script to install')
option('loader_nvram', type: 'string', value: '', description: 'Pass list of pairs of <loader>:<nvram> paths. Both pairs and list items are separated by a colon.')
option('login_shell', type: 'feature', value: 'auto', description: 'build virt-login-shell')
option('nss', type: 'feature', value: 'auto', description: 'enable Name Service Switch plugin for resolving guest IP addresses')
option('numad', type: 'feature', value: 'auto', description: 'use numad to manage CPU placement dynamically')
option('pm_utils', type: 'feature', value: 'auto', description: 'use pm-utils for power management')
option('sysctl_config', type: 'feature', value: 'auto', description: 'Whether to install sysctl configs')
option('tls_priority', type: 'string', value: 'NORMAL', description: 'set the default TLS session priority string')

=== ci/Makefile ===
# -*- makefile -*-
# vim: filetype=make

# The root directory of the libvirt.git checkout
CI_GIT_ROOT = $(shell git rev-parse --show-toplevel)

# The root directory for all CI-related contents
CI_ROOTDIR = $(CI_GIT_ROOT)/ci

# The directory holding content on the host that we will
# expose to the container.
CI_SCRATCHDIR = $(CI_ROOTDIR)/scratch

# The directory holding the clone of the git repo that
# we will expose to the container
CI_HOST_SRCDIR = $(CI_SCRATCHDIR)/src

# The directory holding the source inside the
# container, i.e. where we want to expose
# the $(CI_HOST_SRCDIR) directory from the host
CI_CONT_SRCDIR = $(CI_USER_HOME)/libvirt

# Relative directory to perform the build in. This
# defaults to using a separate build dir, but can be
# set to empty string for an in-source tree build.
CI_VPATH = build

# The directory holding the build output inside the
# container.
CI_CONT_BUILDDIR = $(CI_CONT_SRCDIR)/$(CI_VPATH)

# Can be overridden with mingw{32,64}-configure if desired
CI_CONFIGURE = $(CI_CONT_SRCDIR)/configure

# Default to using all possible CPUs
CI_SMP = $(shell getconf _NPROCESSORS_ONLN)

# Any extra arguments to pass to make
CI_MAKE_ARGS =

# Any extra arguments to pass to configure
CI_CONFIGURE_ARGS =

# Script containing environment preparation steps
CI_PREPARE_SCRIPT = $(CI_ROOTDIR)/prepare.sh

# Script containing build instructions
CI_BUILD_SCRIPT = $(CI_ROOTDIR)/build.sh

# Location of the container images we're going to pull
# Can be useful to override to use a locally built
# image instead
CI_IMAGE_PREFIX = registry.gitlab.com/libvirt/libvirt/ci-

# The default tag is ':latest' but if the container
# repo above uses different conventions this can override it
CI_IMAGE_TAG = :latest

# We delete the virtual root after completion, set
# to 0 if you need to keep it around for debugging
CI_CLEAN = 1

# We'll always freshly clone the virtual root each
# time in case it was not cleaned up before. Set
# to 1 if you want to try restarting a previously
# preserved env
CI_REUSE = 0

# We need the container process to run with current host IDs
# so that it can access the passed in build directory
CI_UID = $(shell id -u)
CI_GID = $(shell id -g)

# We also need the user's login and home directory to prepare the
# environment the way some programs expect it
CI_USER_LOGIN = $(shell echo "$$USER")
CI_USER_HOME = $(shell echo "$$HOME")

CI_ENGINE = auto
# Container engine we are going to use, can be overridden per make
# invocation, if it is not we try podman and then default to docker.
ifeq ($(CI_ENGINE),auto)
	override CI_ENGINE = $(shell podman version >/dev/null 2>&1 && echo podman || echo docker)
endif

# IDs you run as do not need to exist in
# the container's /etc/passwd & /etc/group files, but
# if they do not, then libvirt's 'ninja test' will fail
# many tests.

# We do not directly mount /etc/{passwd,group} as Docker
# is liable to mess with SELinux labelling which will
# then prevent the host accessing them. And podman cannot
# relabel the files due to it running rootless. So
# copying them first is safer and less error-prone.
CI_PWDB_MOUNTS = \
	--volume $(CI_SCRATCHDIR)/group:/etc/group:ro,z \
	--volume $(CI_SCRATCHDIR)/passwd:/etc/passwd:ro,z \
	$(NULL)

CI_HOME_MOUNTS = \
	--volume $(CI_SCRATCHDIR)/home:$(CI_USER_HOME):z \
	$(NULL)

CI_SCRIPT_MOUNTS = \
	--volume $(CI_SCRATCHDIR)/prepare:$(CI_USER_HOME)/prepare:z \
	--volume $(CI_SCRATCHDIR)/build:$(CI_USER_HOME)/build:z \
	$(NULL)

# Docker containers can have very large ulimits
# for nofiles - as much as 1048576. This makes
# libvirt very slow at exec'ing programs.
CI_ULIMIT_FILES = 1024

ifeq ($(CI_ENGINE),podman)
	# Podman cannot reuse host namespace when running non-root
	# containers.  Until support for --keep-uid is added we can
	# just create another mapping that will do that for us.
	# Beware, that in {uid,git}map=container_id:host_id:range, the
	# host_id does actually refer to the uid in the first mapping
	# where 0 (root) is mapped to the current user and rest is
	# offset.
	#
	# In order to set up this mapping, we need to keep all the
	# user IDs to prevent possible errors as some images might
	# expect UIDs up to 90000 (looking at you fedora), so we don't
	# want the overflowuid to be used for them.  For mapping all
	# the other users properly, some math needs to be done.
	# Don't worry, it's just addition and subtraction.
	#
	# 65536 ought to be enough (tm), but for really rare cases the
	# maximums might need to be higher, but that only happens when
	# your /etc/sub{u,g}id allow users to have more IDs.  Unless
	# --keep-uid is supported, let's do this in a way that should
	# work for everyone.
	CI_MAX_UID = $(shell sed -n "s/^$(CI_USER_LOGIN):[^:]\+://p" /etc/subuid)
	CI_MAX_GID = $(shell sed -n "s/^$(CI_USER_LOGIN):[^:]\+://p" /etc/subgid)
	ifeq ($(CI_MAX_UID),)
		CI_MAX_UID = 65536
	endif
	ifeq ($(CI_MAX_GID),)
		CI_MAX_GID = 65536
	endif
	CI_UID_OTHER = $(shell echo $$(($(CI_UID)+1)))
	CI_GID_OTHER = $(shell echo $$(($(CI_GID)+1)))
	CI_UID_OTHER_RANGE = $(shell echo $$(($(CI_MAX_UID)-$(CI_UID))))
	CI_GID_OTHER_RANGE = $(shell echo $$(($(CI_MAX_GID)-$(CI_GID))))

	CI_PODMAN_ARGS = \
		--uidmap 0:1:$(CI_UID) \
		--uidmap $(CI_UID):0:1 \
		--uidmap $(CI_UID_OTHER):$(CI_UID_OTHER):$(CI_UID_OTHER_RANGE) \
		--gidmap 0:1:$(CI_GID) \
		--gidmap $(CI_GID):0:1 \
		--gidmap $(CI_GID_OTHER):$(CI_GID_OTHER):$(CI_GID_OTHER_RANGE) \
		$(NULL)
endif

# Args to use when cloning a git repo.
#  -c  stop it complaining about checking out a random hash
#  -q  stop it displaying progress info for local clone
#  --local ensure we don't actually copy files
CI_GIT_ARGS = \
	-c advice.detachedHead=false \
	-q \
	--local  \
	$(NULL)

# Args to use when running the container
#   --rm      stop inactive containers getting left behind
#   --user    we execute as the same user & group account
#             as dev so that file ownership matches host
#             instead of root:root
#   --volume  to pass in the cloned git repo & config
#   --ulimit  lower files limit for performance reasons
#   --interactive
#   --tty     Ensure we have ability to Ctrl-C the build
CI_ENGINE_ARGS = \
	--rm \
	--interactive \
	--tty \
	$(CI_PODMAN_ARGS) \
	$(CI_PWDB_MOUNTS) \
	$(CI_HOME_MOUNTS) \
	$(CI_SCRIPT_MOUNTS) \
	--volume $(CI_HOST_SRCDIR):$(CI_CONT_SRCDIR):z \
	--ulimit nofile=$(CI_ULIMIT_FILES):$(CI_ULIMIT_FILES) \
	--cap-add=SYS_PTRACE \
	$(NULL)

ci-check-engine:
	@echo -n "Checking if $(CI_ENGINE) is available..." && \
	$(CI_ENGINE) version 1>/dev/null && echo "yes"

ci-prepare-tree: ci-check-engine
	@test "$(CI_REUSE)" != "1" && rm -rf $(CI_SCRATCHDIR) || :
	@if ! test -d $(CI_SCRATCHDIR) ; then \
		mkdir -p $(CI_SCRATCHDIR); \
		cp /etc/passwd $(CI_SCRATCHDIR); \
		cp /etc/group $(CI_SCRATCHDIR); \
		mkdir -p $(CI_SCRATCHDIR)/home; \
		cp "$(CI_PREPARE_SCRIPT)" $(CI_SCRATCHDIR)/prepare; \
		cp "$(CI_BUILD_SCRIPT)" $(CI_SCRATCHDIR)/build; \
		chmod +x "$(CI_SCRATCHDIR)/prepare" "$(CI_SCRATCHDIR)/build"; \
		echo "Cloning $(CI_GIT_ROOT) to $(CI_HOST_SRCDIR)"; \
		git clone $(CI_GIT_ARGS) $(CI_GIT_ROOT) $(CI_HOST_SRCDIR) || exit 1; \
		for mod in $$(git submodule | awk '{ print $$2 }' | sed -E 's,^../,,g') ; \
		do \
			test -f $(CI_GIT_ROOT)/$$mod/.git || continue ; \
			echo "Cloning $(CI_GIT_ROOT)/$$mod to $(CI_HOST_SRCDIR)/$$mod"; \
			git clone $(CI_GIT_ARGS) $(CI_GIT_ROOT)/$$mod $(CI_HOST_SRCDIR)/$$mod || exit 1; \
		done ; \
	fi

ci-run-command@%: ci-prepare-tree
	$(CI_ENGINE) run $(CI_ENGINE_ARGS) $(CI_IMAGE_PREFIX)$*$(CI_IMAGE_TAG) \
		/bin/bash -c ' \
		$(CI_USER_HOME)/prepare || exit 1; \
		sudo \
		  --login \
		  --user="#$(CI_UID)" \
		  --group="#$(CI_GID)" \
		  CONFIGURE_OPTS="$$CONFIGURE_OPTS" \
		  CI_CONT_SRCDIR="$(CI_CONT_SRCDIR)" \
		  CI_CONT_BUILDDIR="$(CI_CONT_BUILDDIR)" \
		  CI_SMP="$(CI_SMP)" \
		  CI_CONFIGURE="$(CI_CONFIGURE)" \
		  CI_CONFIGURE_ARGS="$(CI_CONFIGURE_ARGS)" \
		  CI_MAKE_ARGS="$(CI_MAKE_ARGS)" \
		  $(CI_COMMAND) || exit 1'
	@test "$(CI_CLEAN)" = "1" && rm -rf $(CI_SCRATCHDIR) || :

ci-shell@%:
	$(MAKE) -C $(CI_ROOTDIR) ci-run-command@$* CI_COMMAND="/bin/bash"

ci-build@%:
	$(MAKE) -C $(CI_ROOTDIR) ci-run-command@$* CI_COMMAND="$(CI_USER_HOME)/build"

ci-check@%:
	$(MAKE) -C $(CI_ROOTDIR) ci-build@$* CI_MAKE_ARGS="check"

ci-list-images:
	@echo
	@echo "Available x86 container images:"
	@echo
	@sh list-images.sh "$(CI_IMAGE_PREFIX)" | grep -v cross
	@echo
	@echo "Available cross-compiler container images:"
	@echo
	@sh list-images.sh "$(CI_IMAGE_PREFIX)" | grep cross
	@echo

ci-help:
	@echo "Build libvirt inside containers used for CI"
	@echo
	@echo "Available targets:"
	@echo
	@echo "    ci-build@\$$IMAGE - run a default 'ninja' build"
	@echo "    ci-check@\$$IMAGE - run a 'ninja test'"
	@echo "    ci-shell@\$$IMAGE - run an interactive shell"
	@echo "    ci-list-images  - list available images"
	@echo "    ci-help         - show this help message"
	@echo
	@echo "Available make variables:"
	@echo
	@echo "    CI_CLEAN=0          - do not delete '$(CI_SCRATCHDIR)' after completion"
	@echo "    CI_REUSE=1          - re-use existing '$(CI_SCRATCHDIR)' content"
	@echo "    CI_ENGINE=auto      - container engine to use (podman, docker)"
	@echo "    CI_CONFIGURE_ARGS=  - extra arguments passed to configure"
	@echo "    CI_MAKE_ARGS=       - extra arguments passed to make, e.g. space delimited list of targets"
	@echo

=== debian/changelog ===
libvirt (6.9.0-1+rpi1) bullseye-staging; urgency=medium

  * Disable testsuite

 -- Peter Michael Green <plugwash@raspbian.org>  Thu, 19 Nov 2020 22:35:15 +0000

libvirt (6.9.0-1) unstable; urgency=medium

  * Team upload

  * [9328bc8] New upstream version 6.9.0
  * [88c8a9e] patches: Drop backport/rpc-Fix-virt-ssh-helper-detection.patch

 -- Andrea Bolognani <eof@kiyuko.org>  Sun, 08 Nov 2020 15:33:59 +0100

libvirt (6.8.0-1) unstable; urgency=medium

  * Team upload

  * [a09e8f2] New upstream version 6.8.0
  * [11671ad] patches: Drop backport/[...]gluster-module-dep.patch
  * [d4522ee] patches: Add backport/rpc-Fix-virt-ssh-helper-detection.patch
  * [1012105] libvirt-daemon: Install virt-ssh-helper
  * [1070367] control: Drop Build-Depends on netcat-openbsd
  * [509eb72] control: Drop Build-Depends on libdbus-1-dev

 -- Andrea Bolognani <eof@kiyuko.org>  Wed, 28 Oct 2020 01:08:23 +0100

libvirt (6.7.0-3) experimental; urgency=medium

  * Team upload

  * [2a7b4f4] rules: Decrease timeout for tests to 5m
  * [6337ea2] rules: Make dh_missing errors non-fatal for -indep builds

 -- Andrea Bolognani <eof@kiyuko.org>  Sun, 11 Oct 2020 16:29:18 +0200

libvirt (6.7.0-2) experimental; urgency=medium

  * [7b7ff73] patches: Add backport/[...]gluster-module-dep.patch
  * [a9cc391] debhelper: Use compat level 13
  * [b327f9a] rules: Increase timeout for tests to 15m

 -- Andrea Bolognani <eof@kiyuko.org>  Thu, 10 Sep 2020 18:29:25 +0200

libvirt (6.7.0-1) experimental; urgency=medium

  * Team upload

  * [0d7a347] New upstream version 6.7.0
  * [c6306e9] patches: Drop obsolete patches
    The following patches are no longer necessary:
    - backport/apparmor-allow-default-pki-path.patch
    - backport/apparmor-allow-libvirtd-to-call-pygrub.patch
    - backport/apparmor-allow-libvirtd-to-call-virtiofsd.patch
    - backport/tools-fix-libvirt-guests.sh-text-assignments.patch
    - backport/virdevmapper-Don-t-cache-device-mapper-major.patch
    - backport/virdevmapper-Handle-kernel-without-device-mapper-support.patch
    - backport/virdevmapper-Ignore-all-errors-when-opening-dev-mapper-co.patch
    - debian/Prefer-sbin-over-usr-sbin.patch
  * [72f7997] patches: Rewrite build system patches
    The following patches have been rewritten:
    - debian/Revert-m4-virt-xdr-rewrite-XDR-check.patch
    - debian/Set-defaults-for-zfs-tools.patch
  * [37e7b80] patches: Add debian/Use-sensible-editor-by-default.patch
    Replaces use of the removed --with-default-editor configure option
  * [c326ac4] control: Add Build-Depends on meson

 -- Andrea Bolognani <eof@kiyuko.org>  Tue, 01 Sep 2020 23:26:23 +0200

libvirt (6.6.0-2) unstable; urgency=medium

  * Team upload

  [ Christian Ehrhardt ]
  * fix libvirt-lxc that was broken by libtirpc linking issues (LP: #1892826)
    - [92acaf6] add d/p/debian/Revert-m4-virt-xdr-rewrite-XDR-check.patch
    - [90093c0] Revert "control: Add Build-Depends on libtirpc-dev"
  * [c12faf1] replace patches for pki and pygrub with clean upstream backports
  * [6377d90] apparmor: allow libvirtd to call virtiofsd (LP: #1892736)

 -- Andrea Bolognani <eof@kiyuko.org>  Fri, 28 Aug 2020 17:18:51 +0200

=== debian/control ===
Source: libvirt
Section: libs
Priority: optional
Maintainer: Debian Libvirt Maintainers <pkg-libvirt-maintainers@lists.alioth.debian.org>
Uploaders:
 Guido Günther <agx@sigxcpu.org>,
 Laurent Léonard <laurent@open-minds.org>,
Build-Depends:
 augeas-tools,
 bash-completion,
 debhelper-compat (= 13),
 dh-apparmor [linux-any],
 dnsmasq-base,
 iptables (>= 1.8.1) [linux-any],
 kmod [linux-any],
 libapparmor-dev [linux-any],
 libattr1-dev [linux-any],
 libaudit-dev [linux-any],
 libcap-ng-dev [linux-any],
 libcurl4-gnutls-dev,
 libdevmapper-dev [linux-any],
 libfuse-dev [linux-any],
 libgcrypt20-dev,
 libglusterfs-dev [linux-any],
 libgnutls28-dev,
 libnetcf-dev (>= 1:0.2.3-3~) [linux-any],
 libnl-3-dev [linux-any],
 libnl-route-3-dev [linux-any],
 libnuma-dev [linux-any],
 libparted-dev (>= 2.2),
 libpcap0.8-dev,
 libpciaccess-dev,
 libpolkit-gobject-1-dev [linux-any],
 librados-dev [linux-any],
 librbd-dev [linux-any],
 libreadline-dev,
 libsanlock-dev [linux-any],
 libsasl2-dev,
 libselinux1-dev (>= 2.0.82) [linux-any],
 libssh2-1-dev,
 libudev-dev [linux-any],
 libwireshark-dev (>= 1.11.3),
 libwiretap-dev,
 libxen-dev (>= 4.3) [i386 amd64 armhf arm64],
 libxml2-dev (>= 2.9.2+really2.9.1+dfsg1-0.2),
 libxml2-utils,
 libyajl-dev,
 lvm2 [linux-any],
 meson (>= 0.54.0~),
 nfs-common,
 numad [linux-any],
 open-iscsi [linux-any],
 openssh-client,
 parted (>= 2.2),
 po-debconf,
 policykit-1 (>= 0.105-4~) [linux-any],
 python3,
 python3-docutils,
 qemu-system-common,
 qemu-utils,
 radvd [linux-any],
 systemtap-sdt-dev [linux-any],
 uuid-dev,
 xsltproc,
 zfsutils [kfreebsd-amd64 kfreebsd-i386],
 zlib1g-dev,
Build-Conflicts:
 dpkg-dev (= 1.15.3),
Vcs-Git: https://salsa.debian.org/libvirt-team/libvirt.git
Vcs-Browser: https://salsa.debian.org/libvirt-team/libvirt
Homepage: https://libvirt.org/
Standards-Version: 4.5.0
Rules-Requires-Root: no

Package: libvirt-clients
Section: admin
Architecture: any
Depends:
 libvirt0 (= ${binary:Version}),
 sensible-utils,
 ${misc:Depends},
 ${shlibs:Depends},
Suggests:
 libvirt-daemon,
Description: Programs for the libvirt library
 Libvirt is a C toolkit to interact with the virtualization capabilities
 of recent versions of Linux (and other OSes). The library aims at providing
 a long term stable C API for different virtualization mechanisms. It currently
 supports QEMU, KVM, XEN, OpenVZ, LXC, and VirtualBox.
 .
 This package contains the libvirt shell virsh and other client binaries.

Package: libvirt-daemon
Section: admin
Architecture: any
Depends:
 libvirt-daemon-driver-qemu,
 libvirt0 (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Recommends:
 libvirt-daemon-driver-lxc,
 libvirt-daemon-driver-vbox,
 libvirt-daemon-driver-xen,
 libxml2-utils,
 netcat-openbsd,
 qemu-kvm | qemu (>= 0.9.1),
Suggests:
 libvirt-daemon-driver-storage-gluster,
 libvirt-daemon-driver-storage-rbd,
 libvirt-daemon-driver-storage-zfs,
 libvirt-daemon-system,
 numad,
Enhances:
 qemu,
 qemu-kvm,
 xen,
Description: Virtualization daemon
 Libvirt is a C toolkit to interact with the virtualization capabilities
 of recent versions of Linux (and other OSes). The library aims at providing
 a long term stable C API for different virtualization mechanisms. It currently
 supports QEMU, KVM, XEN, OpenVZ, LXC, and VirtualBox.
 .
 This package contains the daemon libvirtd to manage the hypervisors.

Package: libvirt-daemon-driver-qemu
Section: admin
Architecture: linux-any
Depends:
 libvirt-daemon (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Breaks:
 libvirt-daemon (<< 6.0.0-1~),
Replaces:
 libvirt-daemon (<< 6.0.0-1~),
Description: Virtualization daemon QEMU connection driver
 Libvirt is a C toolkit to interact with the virtualization capabilities
 of recent versions of Linux (and other OSes). The library aims at providing
 a long term stable C API for different virtualization mechanisms. It currently
 supports QEMU, KVM, XEN, OpenVZ, LXC, and VirtualBox.
 .
 This package contains the libvirtd connection driver for QEMU.

Package: libvirt-daemon-driver-lxc
Section: admin
Architecture: linux-any
Depends:
 libvirt-daemon (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Breaks:
 libvirt-daemon (<< 6.0.0-1~),
Replaces:
 libvirt-daemon (<< 6.0.0-1~),
Description: Virtualization daemon LXC connection driver
 Libvirt is a C toolkit to interact with the virtualization capabilities
 of recent versions of Linux (and other OSes). The library aims at providing
 a long term stable C API for different virtualization mechanisms. It currently
 supports QEMU, KVM, XEN, OpenVZ, LXC, and VirtualBox.
 .
 This package contains the libvirtd connection driver for LXC.

Package: libvirt-daemon-driver-vbox
Section: admin
Architecture: amd64 i386
Depends:
 libvirt-daemon (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Breaks:
 libvirt-daemon (<< 6.0.0-1~),
Replaces:
 libvirt-daemon (<< 6.0.0-1~),
Description: Virtualization daemon VirtualBox connection driver
 Libvirt is a C toolkit to interact with the virtualization capabilities
 of recent versions of Linux (and other OSes). The library aims at providing
 a long term stable C API for different virtualization mechanisms. It currently
 supports QEMU, KVM, XEN, OpenVZ, LXC, and VirtualBox.
 .
 This package contains the libvirtd connection driver for VirtualBox.

Package: libvirt-daemon-driver-xen
Section: admin
Architecture: amd64 arm64 armhf i386
Depends:
 libvirt-daemon (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Breaks:
 libvirt-daemon (<< 6.0.0-1~),
Replaces:
 libvirt-daemon (<< 6.0.0-1~),
Description: Virtualization daemon Xen connection driver
 Libvirt is a C toolkit to interact with the virtualization capabilities
 of recent versions of Linux (and other OSes). The library aims at providing
 a long term stable C API for different virtualization mechanisms. It currently
 supports QEMU, KVM, XEN, OpenVZ, LXC, and VirtualBox.
 .
 This package contains the libvirtd connection driver for Xen.

Package: libvirt-daemon-driver-storage-gluster
Section: admin
Architecture: linux-any
Depends:
 libvirt-daemon (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Breaks:
 libvirt-daemon (<< 3.7.0-3~),
Replaces:
 libvirt-daemon (<< 3.7.0-3~),
Description: Virtualization daemon glusterfs storage driver
 Libvirt is a C toolkit to interact with the virtualization capabilities
 of recent versions of Linux (and other OSes). The library aims at providing
 a long term stable C API for different virtualization mechanisms. It currently
 supports QEMU, KVM, XEN, OpenVZ, LXC, and VirtualBox.
 .
 This package contains the libvirtd storage driver for GlusterFS.

Package: libvirt-daemon-driver-storage-rbd
Section: admin
Architecture: linux-any
Depends:
 libvirt-daemon (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Breaks:
 libvirt-daemon (<< 3.7.0-3~),
Replaces:
 libvirt-daemon (<< 3.7.0-3~),
Description: Virtualization daemon RBD storage driver
 Libvirt is a C toolkit to interact with the virtualization capabilities
 of recent versions of Linux (and other OSes). The library aims at providing
 a long term stable C API for different virtualization mechanisms. It currently
 supports QEMU, KVM, XEN, OpenVZ, LXC, and VirtualBox.
 .
 This package contains the libvirtd storage driver for RBD/Rados/Ceph.

Package: libvirt-daemon-driver-storage-zfs
Section: admin
Architecture: linux-any
Depends:
 libvirt-daemon (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Breaks:
 libvirt-daemon (<< 3.7.0-3~),
Replaces:
 libvirt-daemon (<< 3.7.0-3~),
Description: Virtualization daemon ZFS storage driver
 Libvirt is a C toolkit to interact with the virtualization capabilities
 of recent versions of Linux (and other OSes). The library aims at providing
 a long term stable C API for different virtualization mechanisms. It currently
 supports QEMU, KVM, XEN, OpenVZ, LXC, and VirtualBox.
 .
 This package contains the libvirtd storage driver for ZFS.

Package: libvirt-daemon-system
Section: admin
Architecture: any
Pre-Depends:
 ${misc:Pre-Depends},
Depends:
 adduser,
 gettext-base,
 iptables (>= 1.8.1-1) [linux-any] | firewalld,
 libvirt-clients (= ${binary:Version}),
 libvirt-daemon (= ${binary:Version}),
 libvirt-daemon-system-systemd | libvirt-daemon-system-sysv,
 logrotate,
 policykit-1 [linux-any],
 ${misc:Depends},
 ${shlibs:Depends},
Recommends:
 dmidecode,
 dnsmasq-base (>= 2.46-1),
 iproute2,
 mdevctl,
 parted,
Suggests:
 apparmor,
 auditd,
 nfs-common,
 open-iscsi [linux-any],
 pm-utils,
 radvd,
 systemd,
 systemtap,
 zfsutils,
Breaks:
 systemd-sysv (<< 224-1~),
Description: Libvirt daemon configuration files
 Libvirt is a C toolkit to interact with the virtualization capabilities
 of recent versions of Linux (and other OSes). The library aims at providing
 a long term stable C API for different virtualization mechanisms. It currently
 supports QEMU, KVM, XEN, OpenVZ, LXC, and VirtualBox.
 .
 This package contains the configuration files to run the libvirt daemon as a
 system service.

Package: libvirt-daemon-system-systemd
Section: admin
Architecture: any
Depends:
 systemd-container,
 systemd-sysv,
 ${misc:Depends},
 ${shlibs:Depends},
Conflicts:
 libvirt-daemon-system-sysv,
Description: Libvirt daemon configuration files (systemd)
 Libvirt is a C toolkit to interact with the virtualization capabilities
 of recent versions of Linux (and other OSes). The library aims at providing
 a long term stable C API for different virtualization mechanisms. It currently
 supports QEMU, KVM, XEN, OpenVZ, LXC, and VirtualBox.
 .
 This package contains the dependencies to make libvirt work with systemd.
 (this is the default). This package is useless without the
 libvirt-daemon-system package installed.

Package: libvirt-daemon-system-sysv
Section: admin
Architecture: any
Pre-Depends:
 ${misc:Pre-Depends},
Depends:
 lsb-base,
 ${misc:Depends},
 ${shlibs:Depends},
Breaks:
 libvirt-daemon-system (<< 5.6.0-4~),
Replaces:
 libvirt-daemon-system (<< 5.6.0-4~),
Description: Libvirt daemon configuration files (sysv)
 Libvirt is a C toolkit to interact with the virtualization capabilities
 of recent versions of Linux (and other OSes). The library aims at providing
 a long term stable C API for different virtualization mechanisms. It currently
 supports QEMU, KVM, XEN, OpenVZ, LXC, and VirtualBox.
 .
 This package contains dependencies and init scripts to make libvirt work with
 sysv based init systems. Using libvirt-daemon-systemd is preferred since the
 init scripts are incomplete.
 .
 This package is useless without the libvirt-daemon-system package installed.

Package: libvirt0
Architecture: any
Multi-Arch: same
Pre-Depends:
 ${misc:Pre-Depends},
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Recommends:
 lvm2 [linux-any],
Breaks:
 libvirt-daemon (<< 4.10.0-2~),
 selinux-policy-default (<< 2:2.20131214-1~),
 selinux-policy-mls (<< 2:2.20131214-1~),
Replaces:
 libvirt-daemon (<< 4.10.0-2~),
Description: library for interfacing with different virtualization systems
 Libvirt is a C toolkit to interact with the virtualization capabilities
 of recent versions of Linux (and other OSes). The library aims at providing
 a long term stable C API for different virtualization mechanisms. It currently
 supports QEMU, KVM, XEN, OpenVZ, LXC, and VirtualBox.

Package: libvirt-doc
Section: doc
Architecture: all
Depends:
 ${misc:Depends},
Description: documentation for the libvirt library
 Libvirt is a C toolkit to interact with the virtualization capabilities
 of recent versions of Linux (and other OSes). The library aims at providing
 a long term stable C API for different virtualization mechanisms. It currently
 supports QEMU, KVM, XEN, OpenVZ, LXC, and VirtualBox.
 .
 This package contains the documentation.

Package: libvirt-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends:
 libvirt0 (= ${binary:Version}),
 libxen-dev [i386 amd64 armhf arm64],
 ${misc:Depends},
Recommends:
 pkg-config,

=== debian/rules ===
#!/usr/bin/make -f

DEB_RELEASE = $(shell dpkg-parsechangelog -SVersion | sed 's/[^-]\+-//')
DEB_BUILDDATE = $(shell dpkg-parsechangelog -SDate)
DEB_BUILDUSER = $(shell dpkg-parsechangelog -SMaintainer)
NULL =

DEB_BUILD_MAINT_OPTIONS = hardening=+bindnow

# If the build environment sets -Bsymbolic-functions, which is often used as
# hardening option, that would break libvirt build time self-testing.
# Therefore let dpkg-buildflag strip that option if present.
DEB_LDFLAGS_MAINT_STRIP = -Wl,-Bsymbolic-functions

DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk

ifneq (,$(findstring $(DEB_HOST_ARCH_OS), linux))
    ifneq (,$(findstring $(DEB_HOST_ARCH), i386 amd64))
        WITH_VBOX        = -Ddriver_vbox=enabled
    else
        WITH_VBOX        = -Ddriver_vbox=disabled
    endif
    ifneq (,$(findstring $(DEB_HOST_ARCH), i386 amd64 armhf arm64))
        WITH_LIBXL       = -Ddriver_libxl=enabled
        XEN_ENABLED      = 1
    else
        WITH_LIBXL       = -Ddriver_libxl=disabled
    endif
    WITH_STORAGE_LVM     = -Dstorage_lvm=enabled
    WITH_STORAGE_ISCSI   = -Dstorage_iscsi=enabled
    WITH_STORAGE_DISK    = -Dstorage_disk=enabled
    WITH_STORAGE_RBD     = -Dstorage_rbd=enabled
    WITH_STORAGE_GLUSTER = -Dstorage_gluster=enabled
    WITH_UDEV            = -Dudev=enabled
    WITH_CAPNG           = -Dcapng=enabled
    WITH_LIBNL           = -Dlibnl=enabled
    WITH_NETWORK         = -Ddriver_network=enabled
    WITH_OPENVZ          = -Ddriver_openvz=enabled
    WITH_NETCF           = -Dnetcf=enabled
    WITH_POLKIT          = -Dpolkit=enabled
    WITH_SANLOCK         = -Dsanlock=enabled
    WITH_INIT_SCRIPT     = -Dinit_script=systemd
    WITH_FIREWALLD       = -Dfirewalld=enabled
    WITH_ATTR            = -Dattr=enabled
    WITH_AUDIT           = -Daudit=enabled
    WITH_SELINUX         = -Dselinux=enabled -Dsecdriver_selinux=enabled -Dselinux_mount=/sys/fs/selinux
    WITH_APPARMOR        = -Dapparmor=enabled -Dsecdriver_apparmor=enabled -Dapparmor_profiles=true
    WITH_NSS_PLUGIN      = -Dnss=enabled
    WITH_DTRACE          = -Ddtrace=enabled
    WITH_NUMA            = -Dnumactl=enabled -Dnumad=enabled
    ifneq (,$(findstring $(DEB_HOST_ARCH), ia64))
        WITH_LXC         = -Ddriver_lxc=disabled
    else
        WITH_LXC         = -Ddriver_lxc=enabled
    endif
else
    WITH_VBOX            = -Ddriver_vbox=disabled
    WITH_LIBXL           = -Ddriver_libxl=disabled
    WITH_STORAGE_LVM     = -Dstorage_lvm=disabled
    WITH_STORAGE_ISCSI   = -Dstorage_iscsi=disabled
    WITH_STORAGE_DISK    = -Dstorage_disk=disabled
    WITH_STORAGE_RBD     = -Dstorage_rbd=disabled
    WITH_STORAGE_GLUSTER = -Dstorage_gluster=disabled
    WITH_UDEV            = -Dudev=disabled
    WITH_CAPNG           = -Dcapng=disabled
    WITH_LIBNL           = -Dlibnl=disabled
    WITH_NETWORK         = -Ddriver_network=disabled
    WITH_OPENVZ          = -Ddriver_openvz=disabled
    WITH_NETCF           = -Dnetcf=disabled
    WITH_POLKIT          = -Dpolkit=disabled
    WITH_SANLOCK         = -Dsanlock=disabled
    WITH_INIT_SCRIPT     = -Dinit_script=none
    WITH_FIREWALLD       = -Dfirewalld=disabled
    WITH_ATTR            = -Dattr=disabled
    WITH_AUDIT           = -Daudit=disabled
    WITH_SELINUX         = -Dselinux=disabled -Dsecdriver_selinux=disabled -Dselinux_mount=
    WITH_APPARMOR        = -Dapparmor=disabled -Dsecdriver_apparmor=disabled -Dapparmor_profiles=false
    WITH_NSS_PLUGIN      = -Dnss=disabled
    WITH_DTRACE          = -Ddtrace=disabled
    WITH_NUMA            = -Dnumactl=disabled -Dnumad=disabled
    WITH_LXC             = -Ddriver_lxc=disabled
endif

DEB_CONFIGURE_EXTRA_ARGS := \
    --libexecdir=/usr/lib/libvirt \
    -Drunstatedir=/run \
    -Dpackager="$(DEB_BUILDUSER) $(DEB_BUILDDATE)" \
    -Dpackager_version="$(DEB_RELEASE)" \
    -Ddriver_qemu=enabled \
    -Dqemu_user=libvirt-qemu \
    -Dqemu_group=libvirt-qemu \
    -Dqemu_moddir=/usr/lib/$(DEB_HOST_MULTIARCH)/qemu \
    -Ddocs=enabled \
    -Dtests=enabled \
    $(WITH_OPENVZ) \
    -Dsasl=enabled \
    -Dyajl=enabled \
    -Dlibssh2=enabled \
    $(WITH_POLKIT) \
    $(WITH_SANLOCK) \
    $(WITH_UDEV) \
    -Dstorage_fs=enabled \
    -Dstorage_dir=enabled \
    $(WITH_STORAGE_LVM) \
    $(WITH_STORAGE_ISCSI) \
    $(WITH_STORAGE_DISK) \
    -Dstorage_sheepdog=disabled \
    $(WITH_STORAGE_RBD) \
    $(WITH_STORAGE_GLUSTER) \
    -Dstorage_zfs=enabled \
    $(WITH_INIT_SCRIPT) \
    $(WITH_NUMA) \
    $(WITH_SELINUX) \
    $(WITH_APPARMOR) \
    -Ddriver_esx=enabled \
    $(WITH_CAPNG) \
    $(WITH_LIBNL) \
    $(WITH_NETWORK) \
    $(WITH_NETCF) \
    $(WITH_LIBXL) \
    $(WITH_VBOX) \
    $(WITH_LXC) \
    $(WITH_DTRACE) \
    $(WITH_AUDIT) \
    $(WITH_FIREWALLD) \
    $(WITH_ATTR) \
    $(WITH_NSS_PLUGIN) \
    -Dwireshark_dissector=enabled \
    $(NULL)

LIBVIRT_SYSTEM_SERVICES = \
    virtlogd.service \
    virtlockd.service \
    $(NULL)

LIBVIRT_NOSTART_UNITS = \
    libvirt-guests.service \
    libvirtd.socket \
    libvirtd-ro.socket \
    libvirtd-admin.socket \
    virtlogd.socket \
    virtlogd-admin.socket \
    virtlockd.socket \
    virtlockd-admin.socket \
    $(NULL)

DEB_BUILDDIR := $(CURDIR)/debian/build
DEB_DESTDIR := $(CURDIR)/debian/tmp
SRV_MONOLITHIC = libvirt-guests virtlogd virtlockd libvirtd libvirtd-tcp libvirtd-tls virt-guest-shutdown
# For split daemons later, as of 6.0 the remaining elments are
#SRV_SPLIT = virtnwfilterd virtinterfaced virtlxcd virtnetworkd virtnodedevd virtproxyd virtqemud virtsecretd virtstoraged virtvboxd virtxend virtproxyd-tcp virtproxyd-tls

%:
	dh $@ --builddirectory=$(DEB_BUILDDIR)

override_dh_auto_configure:
	dh_auto_configure -- $(DEB_CONFIGURE_EXTRA_ARGS)

# The default timeout for tests in Meson is 30s, which is not enough
# for architectures with slow buildds: make the timeout 10 times
# larger (5m) to account for those
override_dh_auto_test:
	#export LD_PRELOAD=""; \
	#export VIR_TEST_DEBUG=1; \
	#if ! dh_auto_test -- --timeout-multiplier 10; then \
	#    cat $(DEB_BUILDDIR)/meson-logs/testlog.txt; \
	#    exit 1; \
	#fi

# After the upstream build system has installed libvirt into $(DEB_DESTDIR),
# we need to make some tweaks (add a few extra files, delete some contents
# we're not interested in, move things around) so that later calls to the
# various dh_* tools will work optimally. This target is the perfect place
# to perform such operations
override_dh_auto_install:
	dh_auto_install

	# Copy upstream files to debian/ so dh_* can find them
	cp $(DEB_DESTDIR)/usr/lib/libvirt/libvirt-guests.sh \
	   debian/libvirt-daemon-system-sysv.libvirt-guests.init
	cp tools/libvirt-guests.sysconf \
	   debian/libvirt-daemon-system.libvirt-guests.default
	cp src/logging/virtlogd.sysconf \
	   debian/libvirt-daemon-system.virtlogd.default
	cp src/locking/virtlockd.sysconf \
	   debian/libvirt-daemon-system.virtlockd.default

	# Copy the release notes where dh_installdocs can find them
	cp NEWS.rst \
	   $(DEB_DESTDIR)/usr/share/doc/libvirt/NEWS

	# Add our backward compat polkit rule
	mkdir -p $(DEB_DESTDIR)/var/lib/polkit-1/localauthority/10-vendor.d/
	cp debian/polkit/60-libvirt.pkla \
	   $(DEB_DESTDIR)/var/lib/polkit-1/localauthority/10-vendor.d/

	# Rename the upstream polkit rule so that it matches the name used
	# historically in Debian, as well as that of the backwards compat
	# rules we just installed
	mv $(DEB_DESTDIR)/usr/share/polkit-1/rules.d/50-libvirt.rules \
	   $(DEB_DESTDIR)/usr/share/polkit-1/rules.d/60-libvirt.rules

	# Don't ship any files that are managed by the user only
	rm $(DEB_DESTDIR)/etc/apparmor.d/local/*

	# Don't ship the CI dashboard, which is not useful as documentation
	# triggers the privacy-breach-generic Lintian tag
	rm $(DEB_DESTDIR)/usr/share/doc/libvirt/html/ci.html

	# Don't autostart the default network
	rm $(DEB_DESTDIR)/etc/libvirt/qemu/networks/autostart/default.xml

override_dh_install-arch:
	dh_install

ifneq (,$(findstring $(DEB_HOST_ARCH_OS), linux))
